=== debian/changelog ===
rocfft (6.4.3-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 6.4.2.
  * debian/control: set Multi-Arch: same for librocfft0.
  * Run wrap-and-sort.
  * debian/salsa-ci.yml: added. Only build on gfx1100 target.
  * debian/copyright: added myself.
  * debian/control: build-deps on pkg-rocm-tools (>= 0.9.0~exp3).
  * debian/rules: adjust rocm-target-arch option for AMDGPU_TARGETS
    variable.
  * New upstream version 6.4.3.

 -- Andrew Lee (李健秋) <ajqlee@debian.org>  Sun, 10 Aug 2025 10:28:28 +0200

rocfft (6.4.1-1~exp2) experimental; urgency=medium

  * Improve the run-tests runner
  * Use rocm-target-arch to select and document GPU arch
  * Fix typo in variable name in patch
  * Update repo layout to DEP-14

 -- Christian Kastner <ckk@debian.org>  Fri, 11 Jul 2025 17:42:12 +0200
