=== debian/control ===
Source: rocfft
Section: devel
Homepage: https://github.com/ROCm/rocfft
Priority: optional
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rocm-team/rocfft.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocfft
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Maxime Chambonnet <maxzor@maxzor.eu>,
           Cordell Bloor <cgmb@slerp.xyz>,
           Christian Kastner <ckk@debian.org>,
           Kari Pahula <kaol@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               hipcc (>= 5.6.1~),
# end
               libamd-comgr-dev (>= 6.0~),
# ckk 2024-03-02: temporary until hipcc question is resolved:
               libamdhip64-dev (>= 5.6.1~),
               libboost-program-options-dev,
               libfftw3-dev,
               libgtest-dev <!nocheck>,
               libhiprand-dev (>= 5.7.1~),
               libhsa-runtime-dev (>= 5.7.1~),
               libsqlite3-dev,
               pkg-rocm-tools (>= 0.9.0~exp3),
               python3-dev,
               rocm-cmake (>= 5.3.0)
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
                     libjs-jquery <!nodoc>,
                     libjs-mathjax <!nodoc>,
                     libjs-sphinxdoc <!nodoc>,
                     libjs-underscore <!nodoc>,
                     python3-doxysphinx <!nodoc>,
                     python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
                     python3-sphinx-external-toc <!nodoc>
Rules-Requires-Root: no

Package: librocfft0
Section: libs
Architecture: amd64 arm64 ppc64el
Multi-Arch: same
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ROCm library for computing Fast Fourier Transforms - library
 rocFFT is a library for computing the discrete Fourier transform. It is
 built on the AMD ROCm platform and optimized for discrete AMD GPUs.
 .
 rocFFT provides a C99 API and makes use of run-time compilation to create
 optimized execution plans for its computations. The rocFFT library supports
 single and double precision floating point formats for calculating one-, two-
 and three-dimensional transforms for real or complex data of arbitrary length.
 .
 This package provides the AMD ROCm rocFFT library.

Package: librocfft-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: librocfft0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: libamdhip64-dev
Suggests: librocfft-doc
Description: ROCm library for computing Fast Fourier Transforms - headers
 rocFFT is a library for computing the discrete Fourier transform. It is
 built on the AMD ROCm platform and optimized for discrete AMD GPUs.
 .
 rocFFT provides a C99 API and makes use of run-time compilation to create
 optimized execution plans for its computations. The rocFFT library supports
 single and double precision floating point formats for calculating one-, two-
 and three-dimensional transforms for real or complex data of arbitrary length.
 .
 This package provides the AMD ROCm rocFFT development headers.

Package: librocfft0-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Build-Profiles: <!nocheck>
Depends: librocfft0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: ROCm library for computing Fast Fourier Transforms - tests
 rocFFT is a library for computing the discrete Fourier transform. It is
 built on the AMD ROCm platform and optimized for discrete AMD GPUs.
 .
 rocFFT provides a C99 API and makes use of run-time compilation to create
 optimized execution plans for its computations. The rocFFT library supports
 single and double precision floating point formats for calculating one-, two-
 and three-dimensional transforms for real or complex data of arbitrary length.
 .
 This package provides the AMD ROCm rocFFT test binaries. These binaries are
 only used to check whether rocFFT works correctly on a given GPU, so
 generally speaking, users probably don't need this package.

Package: librocfft-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: libjs-mathjax, ${misc:Depends}, ${sphinxdoc:Depends}
Description: ROCm library for computing Fast Fourier Transforms - documentation
 rocFFT is a library for computing the discrete Fourier transform. It is
 built on the AMD ROCm platform and optimized for discrete AMD GPUs.
 .
 rocFFT provides a C99 API and makes use of run-time compilation to create
 optimized execution plans for its computations. The rocFFT library supports
 single and double precision floating point formats for calculating one-, two-
 and three-dimensional transforms for real or complex data of arbitrary length.
 .
 This package provides the AMD ROCm rocFFT documentation.
