=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocfft-$1.tar.gz%" \
    https://github.com/ROCm/rocFFT/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
